/*
communication!
*/
#pragma SFR

#include "external.h"
#include "eeprom.h"

unsigned char get_cs(unsigned char *p,unsigned char num)
{
	unsigned char i, cs1;
	cs1=0;
	for(i=0;i<num;i++)
	{
		cs1+=*p;
		p++;
	}
	return cs1;
}

unsigned char checkmeteradd(void)
{
	unsigned char j;
	allAA_flag=1;//the address is 6 0xAA.
	for(j=2;j<8;j++)
	{
		if(datastring[j]!=0xAA)
      allAA_flag=0;//the address is not 6 0x99s,return 0.
    datacounter=j-2;
		if( (datastring[j]!=s.comm_addr[datacounter])&&(datastring[j]!=0xaa)&&(datastring[j]!=0x99)&&\
       (!( ((datastring[j] &0x0f)==(s.comm_addr[datacounter] &0x0f))&&((datastring[j] &0xf0)==0xa0) )) )//meter number is correct or 0xaa or low half byte is correct and high half byte is 0xa0,and the byte is received correctly.
      return 0;
	}
	return 1;
}
unsigned char check_psd(unsigned char *p)
{
	if( (datastring[16]!=p[0])||(datastring[17]!=p[1])||(datastring[18]!=p[2]) )
	  return 0;
	return 1;
}
void checkpassword(void)
{
 	clearid_flag=0;//=0,clear energy to zero id is wrong.
 	progid_flag=0;//=0,program id is wrong.
	if( (datastring[9]==0x14)||(datastring[9]==0x18) )//check prog id.
	{	
		if(datastring[15]==0x05)//0x04 is popedom of program password.
   	{
    	progid_flag=check_psd(s.progid);//=1,program id is right.
   		if(progid_flag==0)
   			id_error_num++;
   		else
   			{id_error_num=0;
   				progid_flag=1;
   			}
   	}
   	else if(datastring[15]<=0x03)//0x02 is popedom of clear password.
   	{
   		clearid_flag=check_psd(s.clearid);//=1,program id is right.
   		if(clearid_flag==0)
   			id_error_num++;
   	  else
   			{id_error_num=0;
   				clearid_flag=1;
   			}
   	}
   	else
   		{id_error_num++;
   		clearid_flag=0;//=0,clear energy to zero id is wrong.
 	    progid_flag=0;//=0,program id is wrong.
	    }
	}
 	if(id_error_num>2)
 	{
 		disenable_prog_flag=1;//forbid program and clear energy after password error 3 times.
 	}
}

unsigned char receiveframe(void)//receive 1 frame through RS485 or IR,store in data_string.
{
	unsigned char i;
	datastring[stage]=received_data;//here received_data is used for storing data from IR/485.
	if(stage>30)
	{
		goto err_exit;
	}
	else//if(stage<=26)
	{
		if(stage==1)
	  {
		  if(datastring[1]==0x68)//*dataptr
		  	datastring[0]=0xfe;
		  else
		  	return 0;
	  }
	  if(stage==8)
	  {
	  	if(datastring[8]!=0x68)//*dataptr
	  		goto err_exit;
	  }
	  if((stage>9)&&(stage==datastring[10]+12))
	  {
	  	if(received_data==0x16)//here received_data is used for storing data from IR/485.
	  	{
	  		if(checkmeteradd())
	  		{
	  			datacounter=datastring[10]+11;
	  		  if(datastring[datacounter]==get_cs(&datastring[1],datacounter-1))
	  		  {
	  		    for(i=11;i<datacounter;i++)
	  		    {
	  		    	datastring[i]-=0x33;
	  		    }
	  		    checkpassword();
	  		    if(disenable_prog_flag==1)
	  		    	goto err_exit;
	  		    stage=0;
            comm_err_msg=0;//communication error message status word.
            SRMK6=1;//disable INTSR6 (UART) interrupt.
            PMK2=1;//disable IR interrupt.
	  		    return 2;
	  		  }
	  		  else//cs check is error.
	  			  goto err_exit;
	  		}
	  		else//meter address is error.
	  			goto err_exit;
	  	}
	  	else//if(*dataptr!=0x16)
	  		goto err_exit;
	  }
	  stage++;
	  return 1;
	}
	err_exit:
		comm_reset();
		return 0;
}


void prepare_data(void)
{
	unsigned char i;
	cpymemery(&datastring[7],&s.comm_addr[5],6);
	datastring[9]|=0x80;//command.
	datacounter=datastring[10]+11;//here datacounter means the address of CS mapping in datastring.
	for(i=11;i<datacounter;i++)
	{
		datastring[i]+=0x33;
	}
	datastring[datacounter]=get_cs(&datastring[1],datacounter-1);
	datacounter++;
	datastring[datacounter]=0x16;
}
void sendframe(void)//send 1 frame through RS485 or IR.
{
	byteinterval=0;//sending data timing 300ms,if fault,reset comm variables.
  if(ir_485==isir)//if ir_485==isir,IR sends.
  {//ir_send()//send 1 byte stored in data_ptr through IR.
    ir_flag=1;//ir send.
    flag_even=0;
    i_8bit=0;
    i_11bit=0;
    irbyte=*dataptr;
    CR000=0X682;
    TMC00=0X0C;//start TM00.
  }
  else     //if ir_485!=isir,RS485 sends.
  {
    if(stage!=0)//send 1 byte stored in data_ptr through RS485.
      while(ASIF6&0X02);
    TXB6=*dataptr;//send 1 byte.
  }
	dataptr++;
	stage++;
	if(stage<=datacounter)//delay 12ms to send the next byte.
	{ 
//		sending_flag=1;
	if(ir_485==isir)	
		sendbyteinterval=1;//start counting 5 times for 4ms(i.e. 20ms).
	else
		sendbyteinterval=3;
	}
	else//1 frame has been sent.
	{
    comm_flag=1;//to 1s time for communication last.
    if(ir_485==is485)
    {
      comm_reset();//comm_reset_flag=0;//byteinterval=120;//122;//75;
    }
    else
    	ir16left_flag=1;
	}
}
