/*
declare external functions & variables
*/
#define  dis_energy_consant  0x16
#define  energy_consant  16
#define isir 1
#define is485 0
#define light 1
#define dark 0

/***i2c difination***/
#define io_out 0
#define io_in 1
#define i2c_write 0
#define i2c_read 1

#define scl P2.0
#define sda P2.1
#define scl_dir PM2.0
#define sda_dir PM2.1
#define scl_pu PU2.0
#define sda_pu PU2.1

#define pulse P3.0//for pulse.
#define power_dir P4.0//for power's direction.
#define irin P3.1//for IR.
#define irout P4.2//for IR.
#define program_port P4.1//for enable program.
#define clear_port P12.3//for clear all to zero program.
#define comm_led P4.5//to indicate communication status.
#define pulse_led P13.0//to show pulse.
#define e_constant1 P2.2//to indicate energy constant port1.
#define e_constant2 P2.3//to indicate energy constant port2.


#define feed_dog() WDTE=0xAC

/***energy difination***/
extern sreg unsigned char init_flags0;
#define receiving_flag init_flags0.0//=0,no communication or others;=1,one byte has been received,one frame is receiving.
#define sending_flag init_flags0.1//=0,no communication or others;=1,one byte has been sent,one frame is sending.
#define ir_flag init_flags0.2//=0,if IR communication,during receiving;=1,IR sending.
#define ir_485 init_flags0.3//=0,if communication,be 485;=1,be IR.
#define flag_even init_flags0.4//be used to even verify during IR communication.
#define ir16left_flag init_flags0.5//=0,others;=1,during IR sending,the last 16H will be sending.
#define comm_flag init_flags0.6//=0,others;=1,it will tell comm led dark and comm signal on screen to light.
#define power_on_flag init_flags0.7//=0,program comes here first;=1,it is not first that program runs here.

extern sreg unsigned char init_flags1;
#define pps_1s init_flags1.0//=0,others;=1,1s timer has alarmed.
#define enable_program init_flags1.1//=0,program is forbidden;=1,program is allowed.
#define enable_clear init_flags1.2//=0,format eeprom is forbidden;=1,format eeprom is allowed.
#define allAA_flag init_flags1.3//=0,other;=1,meter address is all AAH.
#define progid_flag init_flags1.4//=0,program id is wrong;=1,is right.
#define clearid_flag init_flags1.5//=0,clear energy to zero id is wrong;=1,is right.
#define disenable_prog_flag init_flags1.6//=0,is allowed;=1,password being locked,program and clear energy is void.
#define reverse_power init_flags1.7//=0,power direction is positive;=1,is reverse.

extern sreg unsigned char init_flags2;
#define pulse_flag init_flags2.0//=0,no low frequency pulse;=1,low frequency pulse appears.
#define energy_add_flag init_flags2.1//=0,no add;=1,energy need to be added 0.01 kwh.
#define negative_flag init_flags2.2//=0,others;=1,verify meter error is negative.

extern sreg unsigned char comm_err_msg;//communication error message status word,burden information of communication status.
#define illegal_d_flag comm_err_msg.0//=0,right;=1,other eeror.
#define di0di3_flag comm_err_msg.1//=0,right;=1,data signal error.
#define password_flag comm_err_msg.2//=0,right;=1,password error.

struct serial_address
{
	unsigned char act_energy[4];//active energy.
	unsigned char comm_addr[6];//communicating address.
	unsigned char cf1counter;//active power low frequency pulse counter.
	unsigned char cf1reverse;//reverse power low frequency pulse counter.
	unsigned char clearid[3];//clear password.
	unsigned char progid[3];//program password.
	unsigned char screen_num;//how many screens should the meter display.
	unsigned char display_time;//how long does one screen displaying last.
	unsigned char verify_meter[2];//be used to store divid frequency coefficient.
	};
extern sreg struct serial_address s;
extern sreg unsigned char datastring[35];
//extern sreg unsigned char energy_consant[2];
extern sreg unsigned char disp_buffer[10];
extern unsigned char id_error_num;
extern const unsigned char DI0_DI3_table[7][5];
extern const unsigned int address_table[7];
extern unsigned char received_data;
extern unsigned int div_CF_N;
extern unsigned char power_off;
extern unsigned long residue;
extern unsigned char couter1pps;
extern sreg unsigned char stage;
extern unsigned char datacounter;
extern unsigned char byteinterval;
extern unsigned char sendbyteinterval;
extern unsigned char gotframe;
extern unsigned char *dataptr;
extern unsigned char irbyte;
extern sreg unsigned char i_8bit;
extern sreg unsigned char i_11bit;
extern unsigned char screen;
extern unsigned char dispinterval;
extern bit flag_write_eeprom;
void i2c_writebytes();
void i2c_readbytes();
void format_eeprom();
void delay5ms();
void delay57ms();
void read_eeprom();
void write_eeprom();
void Init_CPU();
void display_on();
void display_off();
void display();
unsigned char receiveframe();
void sendframe();
void cmd_process();
void comm_reset();
void cpymemery();
void prepare_data();