/*
i2c device read/write functions
*/
#pragma SFR
#pragma NOP
#include "external.h"
#include "eeprom.h"


void i2c_stop(void)
{
  sda=0;
  scl=1;
  NOP();
  sda=1;
}
void i2c_sendbyte(unsigned char i2cbyte)
{
  signed char i;//i2c_writebyte();
  for(i=7;i>=0;i--)
  {
    if((i2cbyte>>i)&0x01)
      sda=1;
    else 
      sda=0;
    scl=1;
    NOP();
    NOP();
    scl=0;
  }  //i2c_writebyte();
  scl=1;
  NOP();
  NOP();
  scl=0;
}

void i2c_start_addr(unsigned char device_add,unsigned char read_write)
{
  sda=1;
  scl=1;
  NOP();
  sda=0;
  scl=0;//i2c_start();  
 i2c_sendbyte(device_add | read_write);

}

void i2c_writebytes(unsigned char device_add,unsigned char word_add,\
                    unsigned char *data_ptr,unsigned char num16)
    //write num16(num16 <= 16) bytes from data_ptr to given address.
{
  if(num16>16)
  	num16=16;
  i2c_start_addr(device_add,i2c_write);
  i2c_sendbyte(word_add);
  for(;num16>0;num16--)
  {
    i2c_sendbyte(*data_ptr);
    data_ptr++;
  }
  i2c_stop();
  if((device_add&0xa0)==0xa0)
    delay5ms();
}

void i2c_readbytes(unsigned char device_add,unsigned char word_add,\
                    unsigned char *data_ptr,unsigned char num)//readnum_ee().
      // read num ((num+word_add)<255) bytes from given address(i2c device) to data_ptr(cpu).
{
  unsigned char i2cbyte;//unsigned char byte;
  unsigned char i;
  i2c_start_addr(device_add,i2c_write);
  i2c_sendbyte(word_add);
  i2c_start_addr(device_add,i2c_read);
  for(;num>0;num--)
  {//i2c_recievebyte(unsigned char left_num)
    sda_dir=io_in;
    for(i=0;i<8;i++)//i2c_readbyte();
    {
      i2cbyte=i2cbyte<<1;
      scl=1;
      i2cbyte|=sda;
      NOP();
      scl=0;
    }  
    sda_dir=io_out;
    if(num!=1)//i2c_write_ack();
      sda=0;
    else
      sda=1;
    scl=1;
    NOP();
    NOP();
    scl=0;//write ack to the i2c device during reading.
    *data_ptr=i2cbyte;
    data_ptr++;
  }//i2c_recievebyte(num);
  i2c_stop(); 
}

void display_on(void)
{
	unsigned char i;
  i2c_start_addr(bu9793fs,i2c_write);
  if(power_on_flag==0)//=0,means power raise up;=1,means init_9793 has been done.
  {
  	i2c_sendbyte(0xea);//ICSET:softreset.
    i2c_sendbyte(0xbf);//DISCTL:FR_p4_p3:mode3,Imin;p2:frame=1;SR_p1_p0:high power,Imax.
    i2c_sendbyte(0xfc);//APCTL=0xfc.p1_p0:all pixel normal;APCTL=0xfe.All pixel ON.
    i2c_sendbyte(0xc8);//MODESET:0xc8=p3:display_on=1;p2:1/3bias=0. 0xc0=p3:display_off=0;p2:1/3bias=0.
    power_on_flag=1;

  }
  i2c_sendbyte(0x00);//ADSET=0x00,address is 00h.
  for(i=0;i<10;i++)
  {
  	i2c_sendbyte(disp_buffer[i]);//write data to 9793.
  }
  i2c_stop();
}
void display_off(void)
{
  i2c_start_addr(bu9793fs,i2c_write);
  i2c_sendbyte(0xc0);//MODESET:0xc8=p3:display_on=1;p2:1/3bias=0. 0xc0=p3:display_off=0;p2:1/3bias=0.
  i2c_stop();
}
