
#pragma SFR
#pragma DI
#pragma EI

#include "external.h"
void Init_CPU(void)
{
	unsigned char power_on_counter=0;

	//init_LVI detect,used to interupt.
  LVIS=0x00;//0x00,4.3V //0x04,3.5V //0x06,3.1V //0x08,2.6V.
  LVIM=0x82;//if VCC is below the LVI value,generate signal to apply reset.
  LVION=1;
  feed_dog();
  
  PMC2=0x00;    //PMC2=0,is I/O;PMC2=1,is ADC.
  PM2=0xFC;     //PM=0,output;PM=1,input.
  PU2=0x0C;     //PU=0,pull_up disabled;PU=1,pull_up enabled.
  P2=0X0F;
   
  PM3=0xFF;   //PM=0,output mode.
  PU3=0x03;   //Only input can be pull_up,output can't be pull_up.
  P3=0x13;    //If input,P=1.
  
  PM4=0xD3;   //P40(REVP),P41(INT3)for debugger,P44(RXD)are input.
  PU4=0xff;    //All input ports can be pull_up.
  P4=0x1B;      //If input,P=1;38K=0,TXD=1.
    
  PM12=0xF8;  //If I/O is no use,be output(0) and no link.X1/X2 are reguarded as no use after monitor program.
  PU12=0x08;  //P123(CLEAR) should be pull_up. 
    
  P13.0=0;
    
  //init_TM80 timer
  TMC80=0X84;//enable count,interval is 1/7.81KHz=128us.
  CR80=0x1f;//128us*32=4ms.
    
  //init_TMH1 timer
  TMHMD1=0x01; //Timer counter is disabled,count clock(Fcnt) is fxp=fx=8MHz,interval timer mode,output(0) is enabled.
  CMP01=105;   //105,38kHz for IR,1/38KHz/2/0.125=105.2632.
  TMHE1=0;     //TMHE1=0:IR is disabled;TMHE1=1:IR is active.
    
  //init_TM00 timer
  PRM00=0X01;  //fxp/2^2=8/4=2MHz,clock cycle is 0.5us.
    
  //init_watchdog//reset cycle is 273ms.
  WDTM=0x65;//WDCS4_WDCS3=00,f_WDT uses fRL=240KHz;WDCS2_WDCS1_WDCS0=101,T_WDT=2^16/fRL=273.067ms.
     
  PCC=0;         //PCC and PPCC are for Fcpu. 
  PPCC=0;       //Fcpu=Fx.
    
  //init_interrupt
  MK0=0xDB;//TMMK000=0,PMK0(INTP0 for pulse)=0,interupt is allowed.
  MK1=0xD1;  //0xD5;NO debugger.//0xD1;SRMK6=0,TMMK80=0,PMK3(INTP3 for debugger)=0,PMK2=0(for IR),interupt is allowed.
  INTM0=0x14;//INTP0,INTP1 are all raise edge trager,INTP2 is fall edge trager(1 to 0 detect).
  INTM1=0x01;  //Raise edge of INTP3 can trager interupt.
    
  //void init_UART6(void)
	CKSR6 = 0x05;				// Select fxCLK6=8MHz/2^5=250KHz.
	BRGC6 = 52;					//2400 baud rate,250KHz/2/2400=52.083.
	                    //baud error=(250KHz/2/52-2400)/2400=0.16%,-4.58%<baud error<4.56%.
	ASIM6 = 0x9d;				// 8 data, even parity, 1 stop.
	TXE6 = 1;
	RXE6 = 1;
  ASICL6=0x02;//don't care SBF;DIR=1,LSB first;TXDLV6=0,common output.
  PMK3=1;  
  IF0=0;
  IF1=0;
  do
  {
    delay5ms();    
    power_on_counter++;
    
  }
  while(power_on_counter<20);
	LVIM=0x80;
}

