/*******************************************************************************
*************
*************   9224 energy meter program
*************   ShangHai Getsoon Electronic LTD.
*************   www.gezhou.com
*************   date:2008-11-18
*************   engineer:zhiqiang wang
*************   manager:zhongqi zhang
*************
*******************************************************************************/

#pragma SFR
#pragma DI
#pragma EI
#pragma asm
#pragma NOP

#pragma vect RESET main
#pragma interrupt INTP0 pulse_INTP0
#pragma interrupt INTP2 irin_INTP2
#pragma interrupt INTTM000 irbit_TM00
#pragma interrupt INTTM80 timer4ms_TM80
#pragma interrupt INTSR6 UART_recieve

#include "external.h"
#include "main.h"
#include "eeprom.h"

void energyadd001(unsigned char *point)
{
	unsigned char i,cy;
  cy=1;
  for(i=0;i<4;i++)
  {
  	point[i]+=cy;
  	cy=0;
  	if( (point[i]&0x0f)>0x09)
  	{
  		point[i]+=0x06;
  		if( (point[i]&0xf0)>0x90)
  		{
  			point[i]+=0x60;
  			cy=1;
  		}
  	}
  }
}

void pulse_INTP0(void)
{
//	if(P3.0==1)
	{
		CFH_counter++;
    if(CFH_counter>=div_CF_N)
    {
  	  CFH_counter=0;
  	  pulse_flag=1;
  	  pulse_led=0;//1;//=0,light,show power on;=1,dark,show pulse.
    }
	}
}

void irin_INTP2(void)
{
  SRMK6=1;//disable UART interrupt.
  PMK2=1;//disable IR interrupt.
  byteinterval=0;//recount.
  flag_even=0;
  ir_485=isir;  //it's ir input.
  
  TMC00=0X00;//stop and clear TM00.
  ir_flag=0;//ir receive.
  CR000=0X341;
  TMC00=0X0C;//start TM00.
  
  i_8bit=0;
  i_11bit=0;
  SRIF6=0;//clear INTSR6 interrupt signal.
}
void irbit_TM00(void)
{
  if(ir_flag==0)//ir receive.
  {
    switch(i_11bit)
    {
      case 0:
        if(irin==1)//judge again if start.
          goto error_bit;
        TMC00=0X00;//stop and clear TM00.
        CR000=0X682;
        TMC00=0X0C;//start TM00.
        i_11bit++;
        break;
      case 1:
        if(i_8bit<8)
        {
          irbyte>>=1;
          if(irin==1)
          {
            irbyte|=0x80;
            flag_even=~flag_even;
          }
          i_8bit++;
          if(i_8bit>=8)
          {
            i_11bit++;
          }
        }
        break;
      case 2:
        if(flag_even!=irin)//for parity check.
          goto error_bit;
        i_11bit++;
        break;
      case 3:
        if(irin!=1)//stop.
          goto error_bit;
        i_11bit=0xff;
        PMK2=0;//enable IR interrupt.
        TMC00=0X00;//stop and clear TM00.
        received_data=irbyte;//*dataptr=irbyte;//here received_data is used for storing data from IR/485.
        receiving_flag=1;
        break;
      default:
      error_bit:
      {
        PMK2=0;//enable IR interrupt.
        SRMK6=0;//enable UART interrupt.
        TMC00=0X00;//stop and clear TM00.
      }
    }
  }
  else//ir send.
  {
    switch(i_11bit)
    {
      case 0:
        TMHE1=1;//start bit(0).
        i_11bit++;
        break;
      case 1:
        if(i_8bit<8)
        {
          if(irbyte&0x01)
          {
            TMHE1=0;//IR is disabled(1).
            flag_even=~flag_even;
          }
          else
          {
            TMHE1=1;//IR is active(0).
          }
          irbyte>>=1;
          i_8bit++;
          if(i_8bit>=8)
          {
            i_11bit++;
          }
        }
        break;
      case 2:
        if(flag_even==1)//for parity check.
          TMHE1=0;//IR is disabled.
        else
        {
          TMHE1=1;//IR is active.
        }
        i_11bit++;
        break;
      case 3:
        i_11bit=0xff;
        TMHE1=0;//IR is disabled.//stop(1).
        TMC00=0X00;//stop and clear TM00.
        if(ir16left_flag==1)//(stage==9)//1 frame has been sent.
        {
        	ir16left_flag=0;
          comm_reset();////sendbyteinterval=0xff;
        }
        break;
    }
  }
  PIF2=0;//clear IR interrupt signal.
  SRIF6=0;//clear INTSR6 interrupt signal.
}
void pro4ms()
{flag_4ms=0;
	if(pulse_flag==1)
	{
//		pulse_led=0;//1;//=0,light,show power on;=1,dark,show pulse.
		pulse_width_counter++;
		if(pulse_width_counter>19)//pulse width is 80ms.
		{
			s.cf1counter++;
      if(reverse_power==1)
      {
        s.cf1reverse++;
      }
      if(s.cf1counter>energy_consant)
      {
      	s.cf1counter=0;
      	energy_add_flag=1;
      }
			pulse_led=1;//0;
			pulse_flag=0;
			pulse_width_counter=0;
		}
	}
	if(power_dir==1)
  {
    power_dir_num++;
    if(power_dir_num>3)
    {
      reverse_power=1;//power_dir is reverse power.
    }
  }
  else
  {
    reverse_power=0;
    power_dir_num=0;
  }
  
  if(program_port==0)//=0,means program-port is shorted.
  {
    prog_num++;
    if(prog_num>50)
    {
      enable_program=1;//allow to program.
    }
  }
  else
  {
    enable_program=0;
    prog_num=0;
  }
  if(clear_port==0)//=0,means program-port is shorted.
  {
    clear_num++;
    if(clear_num>50)
    {
      enable_clear=1;//allow to clear energy.
    }
  }
  else
  {
    enable_clear=0;
    clear_num=0;
  }
  
  
  {//IR/485 has received a byte,start 500ms time.
    byteinterval++;
    if(byteinterval==125)
    {
    	comm_reset();
    }
    if(byteinterval>=250)
    {
    	byteinterval=0;
      comm_flag=0;//turn off communication signal.
    }
  }
  couter1pps++;
  if(couter1pps>=250)//second siginal should less than 1 second,because accuracy is not reliable.
  {
    pps_1s=1;
    couter1pps=0;
  }
}
void timer4ms_TM80(void)
{
//	energy_consant[1]=16;
//	if(e_constant1==0)
//	{
//		if(e_constant2==0)
//		  energy_consant[1]=32;
//		else
//			energy_consant[1]=8;
//	}
//	else
//  {
//  	if(e_constant2==1)
//  		energy_consant[1]=16;
//  }
	flag_4ms=1;
  if(sendbyteinterval!=0xff)//sendbyteinterval!=0xff indicates to time 20ms for sending byte through IR or RS485.
  {
  	sendbyteinterval++;
    if(sendbyteinterval>4)
    {
    	sendbyteinterval=0xff;//do not count sendbyteinterval during sending a byte.
      sending_flag=1;//20ms has been reached,set flag to run sendframe().
    }
  }
}

void UART_recieve(void)
{
  PMK2=1;//disable IR interrupt.
  byteinterval=0;//recount.
  ir_485=is485;  //it's RS485 input.
  received_data=RXB6;//here received_data is used for storing data from IR/485.
  if(ASIS6!=0)
  {
    comm_reset();//one of three errors will reset communication.
  }
  else
  {
    receiving_flag=1;//set flag to run receiveframe().
  }
  PIF2=0;//clear IR interrupt signal.
}
void read_eeprom(void)
{
//	unsigned char i;
//	i=(power_on_flag)?1:0;
//	i2c_readbytes(ee_p0,energy_add+i,s.act_energy+i,12-i);//read energy,communication,cf1counter,and cf1reverse address.
	i2c_readbytes(ee_p0,energy_add,s.act_energy,12);
	i2c_readbytes(ee_p0,clearid_add,s.clearid,10);//read password,screen_num,display_time,verify_meter div_CF_N,etc.
	div_CF_N=s.verify_meter[1]*256+s.verify_meter[0];
	if(div_CF_N<=100)
		div_CF_N=1000;
}
void write_eeprom(void)
{flag_write_eeprom=0;
	i2c_writebytes(ee_p0,energy_add,s.act_energy,12);//write energy,communication,cf1counter,and cf1reverse address.
  i2c_writebytes(ee_p0,clearid_add,s.clearid,10);//write password,screen_num,display_time,verify_meter div_CF_N,etc.
}
void initial_variable(void)
{unsigned char i;
  init_flags0=0;
  init_flags1=0;
  init_flags2=0;
  pulse_width_counter=0;
  dispinterval=1;
  id_error_num=0;//times that password is invalid.
  CFH_counter=0;
//  energy_consant[0]=0x00;
  read_eeprom();
  for(i=0;i<10;i++)
    disp_buffer[i]=0xff;
}
void comm_reset(void)
{
  stage=1;
  dataptr=datastring;
  gotframe=0;
  sendbyteinterval=0xff;
  SRMK6=0;//receive error,enable UART interrupt.
  PMK2=0; //receive error,enable IR interrupt.
  TMC00=0X00;//stop and clear TM00.
  TMHE1=0;//IR is disabled(1).
}

void main()
{
  #asm
  movw  AX,#0FEefH
  movw  SP,AX
  #endasm
  
  Init_CPU();
  EI();
  comm_reset();
  initial_variable();
  
  while(1)
  {
  	if(pps_1s==1)
  	{
  		pps_1s=0;
  		dispinterval++;
  		if(s.display_time>9)
  			s.display_time=3;
  		if(dispinterval>s.display_time)
      {
      	dispinterval=1;
      	screen++;
      	if( (s.screen_num>3)||(screen>s.screen_num) )
      		screen=1;
      	display();
      	display_on();//turn on 9793.
      }
  	}
    if(flag_4ms) 
      pro4ms();
    feed_dog();
    if(energy_add_flag==1)
    {
    	energy_add_flag=0;
      energyadd001(s.act_energy);
      if(s.act_energy[0]==0)
		    flag_write_eeprom=1;
    }
    if(receiving_flag==1)
    {
    	receiving_flag=0;
    	gotframe=receiveframe();
    }
    if(gotframe==2)
    {
      
      sendbyteinterval=0;
      cmd_process();      
      prepare_data();
      sendbyteinterval=0;
      gotframe=0;
    }
    if(sending_flag==1)
    {
    	sending_flag=0;
    	sendframe();
    }
    if(enable_clear==1)
    {
    	enable_clear=0;
    	format_eeprom();
    }
    if(flag_write_eeprom)
    	write_eeprom();
    if(LVIF==1)
    {
    	power_off++;
    	if(power_off>3)//3 times check avalible.
    	{write_eeprom();
 //   		i2c_writebytes(ee_p0,energy_add,s.act_energy,4);
    	  //display_off();
    	  while(1);
    	}
    }
    else
    {
    	power_off=0;
    }
  }
}


