#pragma SFR
#include "external.h"
#include "eeprom.h"


unsigned char for99hex(unsigned char num)//convert num less than 99(BCD) to hex.
{
  return num-(num>>4)*6;
}

void multiplication(unsigned char multiplier)
{
	unsigned char i;
	residue=0;//here residue means sum.
	i=multiplier&0x0f;
	while(i--)
	  residue+=div_CF_N;
	multiplier>>=4;
  while(multiplier--)
	  residue+=(div_CF_N<<4);
}
unsigned int division(unsigned int divisor)
{
	unsigned int quotient;
	quotient=0;
	while(residue>=divisor)
	{
		quotient++;
		residue-=divisor;
	}
	return quotient;
}

void cpymemery(unsigned char *p1,unsigned char *p2,unsigned char num)
{
	unsigned char i;
	for(i=num;i>0;i--)
	{
		*p1=*p2;
		p1--;
		p2--;
	}
}
void cpymemery1(unsigned char *p1,unsigned char *p2,unsigned char num)
{
	unsigned char i;
	for(i=0;i<num;i++)
	{
		p1[i]=p2[i];		
	}
}
unsigned char check_di0_di3(void)
{
	unsigned char i,j;
	di0di3_flag=0;
	for(i=0;i<7;i++)
	{
		for(j=0;j<4;j++)
		{
			if(datastring[j+11]!=DI0_DI3_table[i][j])
			{
				break;
			}
			else
			{
				if(j==3)
					return i;
			}
		}
	}
	
		di0di3_flag=1;
	
}
void format_eeprom(void)
{
	unsigned char k,*p;
	p=s.act_energy;
	for(k=0;k<22;k++)
	{
		*p=0;
	 	p++;
	}    
	div_CF_N=1000;
  flag_write_eeprom=1;
//  write_eeprom();
//  read_eeprom();
}

void read_data(void)//read data.
{
	unsigned char k;
	k=check_di0_di3();
	if( (k==2)||(k==3)||(k==7)||(di0di3_flag==1) )
		goto exit_read;
	if(datastring[10]!=4)//datalength is 4 bytes.
	{
		illegal_d_flag=1;
		goto exit_read;
	}
//	i2c_readbytes(ee_p0,address_table[k],&datastring[15],DI0_DI3_table[k][4]);
   cpymemery1(&datastring[15],address_table[k],DI0_DI3_table[k][4]);
//	if(k==0)
//		datastring[15]=s.act_energy[0];
  datastring[10]=DI0_DI3_table[k][4]+4;
	return;
exit_read:
	datastring[9]=0xd1;
	datastring[10]=1;
	datastring[11]=comm_err_msg;
}

void write_data(void)
{
	unsigned char k;
	unsigned int temp;
	
	k=check_di0_di3();
	if( ( (progid_flag==0)&&(clearid_flag==0) )\
		       ||(disenable_prog_flag==1)||(di0di3_flag==1) )//progid_flag,clearid_flag is 1 means program id is right.
	{
    password_flag=1;
    goto exit_write;
  }
  if( ((k==2)||(k==3)) )//k=2,is clear password or k=3,program password.
  {
//  	if( (datastring[15]!=(datastring[19]+1))||(datastring[19]>datastring[23]))
  	if(datastring[19]>datastring[23])
  	{
  		password_flag=1;
      goto exit_write;
  	}
  	if(datastring[19]<datastring[23])
  		k=3;
 		flag_write_eeprom=1;
 		cpymemery1(address_table[k],&datastring[24],DI0_DI3_table[k][4]);
//  	i2c_writebytes(ee_p0,address_table[k],&datastring[20],DI0_DI3_table[k][4]);
//  	goto exit_id;
    return;
  }
if(k==6)
  {
  	if(datastring[24]>=0x80)
	  {
		  datastring[24]&=0x7f;
		  negative_flag=1;
	  }
	  datastring[23]=for99hex(datastring[23]);
  	datastring[24]=for99hex(datastring[24]);
  	multiplication(datastring[24]);//after this step residue is dividend.
  	datastring[24]=(unsigned char)division(100);//return value of division() is quotient.
  	temp=(unsigned int)residue<<6;//residue*100.
  	multiplication(datastring[23]);//after this step residue is dividend.
  	datastring[23]=(unsigned char)division(10000);//return value of division() is quotient.
  	residue+=temp;
  	datastring[25]=(unsigned char)division(10000);//return value of division() is quotient.
  	if(residue>5000)
  		datastring[25]++;//adjust calculation result to real value.
	  if(negative_flag==0)
  	  div_CF_N=div_CF_N+datastring[23]+datastring[24]+datastring[25];//div_CF_N is divid frequency coefficient.
    else
    {
    	negative_flag=0;
    	div_CF_N=div_CF_N-datastring[23]-datastring[24]-datastring[25];
    }
    datastring[23]=(unsigned char)div_CF_N;
    datastring[24]=(unsigned char)(div_CF_N>>8);
  }
if (k==0) 
		goto exit_write; 

		cpymemery1(address_table[k],&datastring[23],DI0_DI3_table[k][4]);
		flag_write_eeprom=1;   
//	i2c_writebytes(ee_p0,address_table[k],&datastring[19],DI0_DI3_table[k][4]);
//exit_id:
//	read_eeprom();
	return;
exit_write:
  datastring[9]=0xd4;
	datastring[10]=1;
	datastring[11]=comm_err_msg;
}

void cmd_process(void)
{
  unsigned char i;
  switch(datastring[9])//datastring[9] is the command byte received.
  {
    case 0x11://read data.
      read_data();
      break;
    case 0x18://modify ID.
    case 0x14://write data.
    	if(enable_program!=1)
    		goto exit_cmd;	
      write_data();
	    datastring[10]=(datastring[9]==0xd4)?1:0;//ack data length of write data.
      break;
    case 0x13://read address.
    	if(allAA_flag!=1)
    	{
    		goto exit_cmd;
    	}
    	cpymemery(&datastring[16],&s.comm_addr[5],6);
    	datastring[10]=6;
      break;
    case 0x15://write address.
    	if(enable_program!=1)
    		goto exit_cmd;
    	if(allAA_flag!=1)
    	{
    		goto exit_cmd;
    	}
    	cpymemery(&s.comm_addr[5],&datastring[16],6);
    	flag_write_eeprom=1;
    	datastring[10]=0;
      break;
    case 0x1a://clear energy.
    	if(enable_program!=1)
    		goto exit_cmd;
    	if(disenable_prog_flag==1)
    	{
        goto exit_clear;
      }
    	if( (datastring[11]!=2)||(datastring[12]!=s.clearid[0])\
    		 ||(datastring[13]!=s.clearid[1])||(datastring[14]!=s.clearid[2]) )
    	{
    		id_error_num++;
        goto exit_clear;
    	}
    	s.act_energy[0]=0x0;
    	s.act_energy[1]=0x0;
    	s.act_energy[2]=0x00;
    	s.act_energy[3]=0x00;
    	flag_write_eeprom=1;
      break;
    case 0x1f://format eeprom.
    	if(enable_program!=1)
    		goto exit_cmd;
    	format_eeprom();
      break;
    default:
  exit_cmd:
  	sendbyteinterval=0xff;
    comm_reset();
    return;
  exit_clear:
    password_flag=1;
    datastring[9]=0xda;
    datastring[10]=0x01;
	  datastring[11]=comm_err_msg;
  }
}
